/*
	NEC Avenue/JHV .FLK Archive
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

unsigned char	fileheader[2] = { 0x00, 0x00 };

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	char				*tmp[11];
	unsigned char		*buf;
	unsigned char		*filebuf;
	unsigned long		header_length = 0L;
	unsigned int		file_count = 0;
	unsigned long		file_ed = 0L;

	char				header_filename[12];
	unsigned long		header_filest = 0L;
	unsigned long		header_fileed = 0L;
	unsigned long		header_filesize = 0L;

	char				out_filename[256];
	unsigned long		nowsize = 0L;

	unsigned int		i;

	printf( "NEC/JHV FLK Divider 071111 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: FLKDIV <filename> <dest_dir>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	fread( tmp, 2, 1, in );
	if( memcmp( tmp, fileheader, 2 ))
	{
		printf( "error: not FLK format.\n" );
		goto end2;
	}

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );

	/* Header size */
	header_length = 0x200;

	/* Read header */
	buf = ( unsigned char * )calloc( 1, header_length );
	fseek( in, 0, SEEK_SET );
	fread( buf, header_length, 1, in );

	printf( "header_length: %lu(%04lX)\n", header_length, header_length );

	/* file_count */
	for( i = 0; i != 32; i++ )
	{
		if( buf[i*0x10+4] != 0 ) file_count++;
	}

	printf( "file_count: %d\n", file_count );
	printf( "file_size: %lu bytes\n", file_ed );
	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		memcpy( header_filename, &buf[i*0x10+4], 12 );

		header_filest = *( unsigned int *)( buf + ( i * 0x10 ));
		header_filest *= 16;
		header_filest += 0x200;

		if( i == file_count - 1 ) header_fileed = file_ed;
		else {
			header_fileed = *( unsigned int *)( buf + ( i * 0x10 ) + 0x10 );
			header_fileed *= 16;
			header_fileed += 0x200;
		}
		header_filesize = header_fileed - header_filest;

		printf( "%03d %-13s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		if( ac == 3 )
		{
			sprintf( out_filename, "%s%s",
				av[2],
				header_filename
			);
		} else sprintf( out_filename, "%s", header_filename );

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		filebuf = ( unsigned char * )calloc( 1, 32768 );	/* 32k */
		nowsize = header_filesize;
		fseek( in, header_filest, SEEK_SET );

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );
		printf( ".\n" );
		fclose( out );

		free( filebuf );

	}

	printf( "\n" );
	printf( "complete.\n" );

end:;
	free( buf );
end2:;
	fclose( in );
	return;
}
